/*  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
 
Auteur : Delhomme Olivier (http://src.delhomme.org/)

version 0.0.4 (23.01.2004) 
  Ajout de l'option --preserve ou -p)
  Corrections de quelques bugs ou oublis, mise en conformit du code C
  Commentaires ajouts dans le code

version 0.0.3 (06.11.2002) 
  Ecriture des noms de fichiers en majuscule, pour viter que les systme FAT32
  ne se plaignent lors de la copie de deux fichiers nomms foo et Foo !
  Ds lors les fichiers seront copis comme FOO, et le mcanisme de sauvegarde 
  dans un autre rpertoire sera mis  contribution. (option --fat32 ou -c)

version 0.0.2 (12.09.2002)
  La premire version qui est apparue pour permettre le tri de centaines de
  milliers de fichiers. */


#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <utime.h>

#include "coupe.h"

char *prog_name;

int cp(char *nomfichier, char *nomfichier2, Options opt)
{
  /* Copie nomfichier vers nomfichier2 si possible */

  FILE *fp;
  FILE *fp2;
  int filedes;
  struct stat *buf;
  struct utimbuf *buf_time;
  int lus;
  int val;
  char *buffer;

  val = TRUE;
  buffer = (char*) malloc (sizeof(char) * TAILLE_BUFFER);
  buf_time = (struct utimbuf *) malloc (sizeof(struct utimbuf));

  if ((fp = fopen(nomfichier, "r")) != NULL) /* Si on peux ouvrir le fichier */
    {
      buf = (struct stat*) malloc (sizeof(struct stat));
      filedes=fileno(fp);
      fstat(filedes, buf);
      if (S_ISREG(buf->st_mode))
	{
	  /* vrification de l'existence du fichier ! */
	  if ((fp2 = fopen(nomfichier2, "r")) != NULL)
	    {
	      val = EXISTE;
	      if (opt.debug == TRUE)
		fprintf(stdout, "cp - Le fichier %s existe dj.\n", nomfichier2);
	      fclose(fp2);
	    }
	  else
	    {
	      if ((fp2 = fopen(nomfichier2, "w")) != NULL)
		{
		  while (!feof(fp))
		    { /* la vritable copie s'effectue ici ! */
		      lus = fread(buffer, 1, TAILLE_BUFFER, fp);
		      fwrite(buffer, 1, lus, fp2);
		    }
		  fclose(fp2);
		  buf_time->actime = buf->st_atime;
		  buf_time->modtime = buf->st_mtime;
		  utime(nomfichier2, buf_time);
		}
	      else
		{
		  val = ERREUR;
		  if (opt.debug == TRUE)
		    fprintf(stdout, "cp - Erreur lors de l'ouverture du fichier %s.\n", 
                            nomfichier2);
		}
	    }
	}
      else
	{
	  val = ERREUR;
	  if (opt.debug == TRUE)
	    fprintf(stdout, "cp - Le fichier %s n'est pas un fichier normal (%d)!\n", 
                    nomfichier, buf->st_mode);
	}
      fclose(fp);
    }
  else
    {
      val = ERREUR;
      if (opt.debug == TRUE)
	fprintf(stdout, "cp - Erreur lors de l'ouverture du fichier %s.\n", nomfichier);
    }
  return val;
}


int cp_existe(char *nomfichier, char *nomfichier2, Options opt, int *nb)
{
  /* Nom du fichier  copier (avec le rpertoire complet),
     Nom du fichier sans le rpertoire,
     Options du programme,
     Calculs du nb de fichier par rpertoire.
  */
  
  int j;
  int val;
  char *nomfinal;
  j=0;

  while (j<(MAXREP-1) && nb[j+1]>opt.lignes)
    j++;

  nomfinal = (char*) malloc (sizeof(char) * MAX_FILENAME);
  sprintf(nomfinal, "%s/a%d/%c", opt.destination, j, '\0');
  mkdir(nomfinal, 493);
  sprintf(nomfinal, "%s/a%d/%s%c", opt.destination, j, nomfichier2, '\0');
  while ((val = cp(nomfichier, nomfinal, opt)) == EXISTE)
    {
      j++;
      while ( j < (MAXREP-1) && nb[j+1] > opt.lignes)
	j++;
      sprintf(nomfinal, "%s/a%d/%c", opt.destination, j, '\0');
      mkdir(nomfinal, 493);
      sprintf(nomfinal, "%s/a%d/%s%c", opt.destination, j, nomfichier2, '\0');
    }
  nb[j+1]++;
  free(nomfinal);
  return val;
}


int do_copie(FILE *fp, Options opt)
{
  char *nomfichier;    /* Le nom du fichier en cours (issu de la liste)   */
  char *nomrepertoire; /* Le nom du rpertoire en cours                   */ 
  char *nomfichier2;   /* Le nom du fichier de destination                */
  char c[2];
  int i;  /* Pour compter le nombre de caractres dans le nom du fichier; */
  int nb[MAXREP+1]; /* Pour connaitre le nombre de fichiers traits       */
  int j;  /* Pour connaitre le numro du rpertoire;                      */
  int nbcar;
  int txtlong;
  int val;
  int totalite;
  int erreurs;

  /* Initialisations diverses */
  totalite = 0;
  for (i = 0; i < MAXREP; i++)
    nb[i] = 0;

  nbcar = 0;
  i = 0;
  j = -1;      /* Comme a on commence  0 !! */
  erreurs = 0; /* tout du moins au dbut !!! */

  if (opt.debug == TRUE)
    fprintf(stdout, "Ok.\nListing is %s and destination directory is %s\n",
            opt.filename, opt.destination);

  nomfichier = (char*) malloc (sizeof(char) * MAX_FILENAME);
  nomrepertoire = (char*) malloc (sizeof(char) * MAX_FILENAME);
  nomfichier2 = (char *) malloc (sizeof(char) * (MAX_FILENAME));

  while (!feof(fp))
    {
      /* lecture des donnes de type find -print0,  ce qui permet de copier
         des fichiers avec des noms qui comportent des caractres bizzares 
         comme par exemple avec des \n dedans ! */
      fread(c, sizeof(char), 1, fp);
      i=0;
      while (!feof(fp) && c[0] != '\0')
	{
	  nomfichier[i] = c[0];
	  i++;
	  fread(c, sizeof(char), 1, fp);
	}
      nomfichier[i] = '\0';
      /* fin de cette lecture (on a un nom de fichier a copier) */
      
      if (nb[0] == 0)
	{/* cration du rpertoire pour stocker les fichiers */
	  j++;
	  sprintf(nomrepertoire, "%s/%d/", opt.destination, j);
	  mkdir(nomrepertoire, 493);
	}
      
      /* pour garder la structure originelle du chemin */
      txtlong = strlen(nomfichier); 
      if (opt.preserve == TRUE)
	{
	  nbcar = 0; 
	}
      else
	{
	  nbcar = txtlong;
	  while (nomfichier[nbcar] != '/' && nbcar >= 0) 
	    {
	      nbcar--;
	    }
	  nbcar++;
	}
      
      /* extraction du nom du fichier (si besoin) */
      if (opt.fat32 == TRUE)
	{ /* compatibilt fat32 (mise en majuscule) */
	  i=0;
	  while (nbcar < txtlong && i < MAX_FAT32)
	    {
	      nomfichier2[i] = toupper(nomfichier[nbcar]);
	      i++;
	      nbcar++;
	    }
	}
      else
	{
	  i=0;
	  while (nbcar < txtlong && i < MAX_FILENAME)
	    {
	      nomfichier2[i] = nomfichier[nbcar];
	      i++;
	      nbcar++;
	    }
	}

      nomfichier2[i] = '\0';
      sprintf(nomrepertoire, "%s/%d/%s%c", opt.destination, j, nomfichier2, '\0');

      /* fonctionalit demande par GruiicK :
         'On ne sait pas ce qu'il fait ton machin bidule l !' */
      if (opt.debug == TRUE || opt.text == TRUE)
	fprintf(stdout, "%d : %s --> %s (%s)\n", nb[0], nomfichier, 
                nomrepertoire, nomfichier2);
      
      val = cp(nomfichier, nomrepertoire, opt); 

      if (val == EXISTE)
	{
	  val = cp_existe(nomfichier, nomfichier2, opt, nb);
	}
      else
	{
	  if (val == ERREUR && opt.erreur == TRUE)
	    {
	      fprintf(stdout, "%s\n", nomfichier);
	      erreurs++;
	    }
	  else
	    nb[0]++;
	    
	}
      if (nb[0] == (opt.lignes))
	nb[0] = 0;
    }

  for (i=0; i<MAXREP; i++)
    totalite += nb[i];

  totalite += (j * opt.lignes);

  if (opt.debug == TRUE)
    fprintf(stdout, "%d Fichiers Copis et %d erreur(s).\n", totalite, erreurs);
  free(nomrepertoire);
  free(nomfichier2);			 
  free(nomfichier);
  return TRUE;
}

void version()
{
  fprintf(stdout, "%s, %s - %s - Version %s\n", prog_name, Auteur, 
          Date, Version);  
}

int usage(int status)
{
 if (status != 0)
    {
      fprintf (stderr, 
	       "Pour en savoir davantage, faites: `%s --help'\n", prog_name);
    }
  else
    {
      version();
      fprintf(stdout, "\nPermet de copier les fichiers d'une liste dans plusieurs rpertoires.\n\
Le fichier de liste (FICHIER) doit tre de la forme -print0 de la commande find\n");
      fprintf(stdout, "\nUsage : \n\
  %s [options] FICHIER Destination\n", prog_name);
      fprintf(stdout, "\nOptions :\n\
  -h, --help\t\tCette aide.\n\
  -v, --version\t\tAffiche la version du programme.\n\
  -f, --files=NBFILES\tFixe le nombre de fichiers pour chaque rpertoire.\n\
  -t, --text\t\tDonne le nom du fichier en cours de copie.\n\
  -c, --fat32\t\tPermet la compatibilit des noms avec le systme de fichiers FAT32\n\
  -p  --preserve\tGarde les chemins originaux pour faire les copies\n\ 
  -e, --errors\t\tAffiche les erreurs rencontres\n\
  -d, --debug\t\tAffiche les messages permettant un ventuel dbuggage\n\
  ");
      fprintf(stdout, "\nSorties :\n\
  Les fichiers dans des rpertoires Destination/0, Destination/1 ...\n");
    }
 return TRUE;
}


int main (int argc, char ** argv)
{  
  Options opt;

  FILE *fp,*fp2;  /* les pointeurs de fichiers */
  int filedes;    /* les deux descripteurs qui leurs correspondent */
  int filedes2;
  struct stat *buf;  /* deux buffers pour les stats ncessaires */
  struct stat *buf2;
  int c;
  int help;
  int val;

  /* Initialisations des paramtres */
  opt.lignes = DEFLIGNES;  /* nombre de lignes par dfaut (pour les sous listes) */
  opt.filename = NULL;     /* Nom du fichier de la liste principale              */
  opt.debug = FALSE;       /* Par dfaut on debug pas !                          */
  opt.erreur = FALSE;      /* Par dfaut on n'affiche pas les erreurs            */
  opt.fat32 = FALSE;       /* Mais qui a besoin d'une telle compatibilit ;)     */
  opt.text = FALSE;        /* Option de documentation des actions du programme   */
  opt.preserve = FALSE;    /* Les chemins originaux sont prservs ...           */

  val = TRUE;   /* Valeur de retour du programme                  */
  help = FALSE; /* Aide, non demande par dfaut (--help)         */
  c = 0;        /* Nombre de paramtres de la ligne de commande   */

  prog_name = argv[0];

  while ((c = getopt_long (argc, argv, "vhdeftcp", long_options, NULL)) != -1)
    {
      switch (c)
	{
	case 0:			/* options longues */
	  break;
	  
	case 'v':
	  version();
	  break;
	 
	case 'h':
	  help = TRUE; 
	  break;
	
	case 'd':
	  opt.debug = TRUE; 
	  break;

	case 'e':
	  opt.erreur = TRUE; 
	  break;
	  
	case 't':
	  opt.text = TRUE; 
	  break;

	case 'c':
	  opt.fat32 = TRUE; 
	  break;

	case 'p':
	  opt.preserve = TRUE;
	  break;

	case 'f':
	  if (optarg)
	    {
	      if (sscanf(optarg, "%d", &opt.lignes) < 1)
		opt.lignes = DEFLIGNES;
	    }
	  else
	    opt.lignes = DEFLIGNES;
	  break;

	default:
	  val = usage(1);
	}
    }

  /* les arguments qui ne sont pas dans ceux dfinis : */
  if (optind < argc)
    {
	  opt.filename = (char*) malloc (sizeof(char) * strlen(argv[optind]) + 1);
	  strcpy(opt.filename, argv[optind]);
	  optind++;
	  
	  opt.destination = (char*) malloc (sizeof(char) * strlen(argv[optind]) + 1);
	  strcpy(opt.destination, argv[optind]);
	  optind++;

	  if ((fp = fopen(opt.filename, "r")) != NULL) /* Si on peux ouvrir le fichier */
	    {
	      buf = (struct stat*) malloc (sizeof(struct stat));
	      filedes=fileno(fp);
	      fstat(filedes, buf);
	      if (S_ISREG(buf->st_mode))  /* Si il s'agit d'un fichier normal */
		{/* vrification que Destination est bien un rpertoire       */
		  if ((fp2 = fopen(opt.destination, "r")) != NULL)
		    {
		      buf2 = (struct stat*) malloc (sizeof(struct stat));
		      filedes2 = fileno(fp2);
		      fstat(filedes2, buf2);
		      if (S_ISDIR(buf2->st_mode))
			{/* on fait le traitement */
			  val = do_copie(fp, opt);
			}
		      else
			{
			  if (opt.erreur == TRUE)
			    fprintf(stdout, "main - La destination n'est pas un rpertoire.\n");
			  val = ERREUR;
			}
		      free(buf2);
		      fclose(fp2);
		    }
		  else
		    {
		      if (opt.erreur == TRUE)
			fprintf(stdout, "main - Erreur lors de l'ouverture du fichier %s.\n", 
                                opt.destination);
		      val = ERREUR;
		    }
		}
	      else
		{
		  if (opt.erreur == TRUE)
		    fprintf(stdout, "main - Le Fichier %s n'est pas un fichier ordinaire.\n",
                            opt.filename);
		  val = ERREUR;
		}
	      free(buf);
	      fclose(fp);
	    }
	  else
	    {
	      if (opt.erreur == TRUE)
		fprintf(stdout, "main - Erreur lors de l'ouverture du fichier %s.\n",
                        opt.filename);
	      val = ERREUR;
	    }
	  free(opt.filename);	
    }
  else
    {
      if (help == TRUE)
	val = usage(0);
    }

  return val;
}
