// Constantes et structures ... 
#define _GNU_SOURCE
#include <getopt.h>

#define Auteur "Olivier Delhomme"
#define Date "12 09 2002"
#define Licence "GPL"
#define Version "0.0.4 (23.01.2004)"

#define DEFLIGNES 1000
#define MAX_FILENAME 65535 // taille maximale d'un nom de fichier avec le chemin
#define MAX_FAT32 255      // taille maximale pour les noms en FAT32
#define TAILLE_BUFFER 4096 // taille d'un buffer : 4 ko (une page normalement)
#define MAXREP 1000        // nombre maximal de fichier dans un rpertoire

// Autres constantes.
#define TRUE 0
#define FALSE 1
#define ERREUR 3 
#define EXISTE 122


typedef struct
{
  int lignes;        // Nombre de lignes a lire pour un mme rpertoire
  char *filename;    // Nom du fichier comportant la liste des fichiers a copier
  char *destination; // Nom du rpertoire de destination
  int debug;         // Pour debuggage
  int erreur;        // Affichage des erreurs
  int text;
  int fat32;         // Pour assurer la compatibilit de la fat32
  int preserve;      // Pour garder l'intgralit du chemin
} Options;


static struct option const long_options[] =
{
  {"version", no_argument, NULL, 'v'},
  {"help", no_argument, NULL, 'h'},
  {"debug", no_argument, NULL, 'd'},
  {"errors", no_argument, NULL, 'e'},
  {"files", optional_argument, NULL, 'f'},
  {"text", no_argument, NULL, 't'},
  {"fat32", no_argument, NULL, 'c'},
  {"preserve", no_argument, NULL, 'p'},
  {NULL, 0, NULL, 0} 
};
